diff --git a/src/main/java/net/minecraft/core/block/TorchBlock.java b/src/main/java/net/minecraft/core/block/TorchBlock.java
index 2481adc2c..7d2734603 100644
--- a/src/main/java/net/minecraft/core/block/TorchBlock.java
+++ b/src/main/java/net/minecraft/core/block/TorchBlock.java
@@ -19,6 +19,14 @@ import java.util.Random;
 
 public class TorchBlock extends Block
 {
+    public static final int MASK_DIRECTION = 0b0000_0111;
+    public static final int SIDE_NONE = 0;
+    public static final int SIDE_WEST = 1;
+    public static final int SIDE_EAST = 2;
+    public static final int SIDE_NORTH = 3;
+    public static final int SIDE_SOUTH = 4;
+    public static final int SIDE_BOTTOM = 5;
+    public static final int SIDE_TOP = 6;
 
 	public TorchBlock(String key, String namespaceId, int id)
     {
@@ -73,37 +81,48 @@ public class TorchBlock extends Block
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
-    	int l = side.getId();
-        int i1 = world.getBlockMetadata(x, y, z);
-        if(l == 1 && canPlaceOnTop(world, x, y - 1, z))
-        {
-            i1 = 5;
-        }
-        if(l == 2 && world.isBlockNormalCube(x, y, z + 1))
-        {
-            i1 = 4;
-        }
-        if(l == 3 && world.isBlockNormalCube(x, y, z - 1))
-        {
-            i1 = 3;
-        }
-        if(l == 4 && world.isBlockNormalCube(x + 1, y, z))
-        {
-            i1 = 2;
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+        int orientation = SIDE_NONE;
+        switch (side) {
+            case TOP:
+                if(canPlaceOnTop(world, x, y - 1, z))
+                {
+                    orientation = SIDE_BOTTOM;
+                }
+                break;
+            case NORTH:
+                if(world.isBlockNormalCube(x, y, z + 1))
+                {
+                    orientation = SIDE_SOUTH;
+                }
+                break;
+            case SOUTH:
+                if(world.isBlockNormalCube(x, y, z - 1))
+                {
+                    orientation = SIDE_NORTH;
+                }
+                break;
+            case WEST:
+                if(world.isBlockNormalCube(x + 1, y, z))
+                {
+                    orientation = SIDE_EAST;
+                }
+                break;
+            case EAST:
+                if(world.isBlockNormalCube(x - 1, y, z))
+                {
+                    orientation = SIDE_WEST;
+                }
+                break;
         }
-        if(l == 5 && world.isBlockNormalCube(x - 1, y, z))
-        {
-            i1 = 1;
-        }
-        world.setBlockMetadataWithNotify(x, y, z, i1);
+        world.setBlockMetadataWithNotify(x, y, z, orientation);
     }
     
     @Override
 	public void updateTick(World world, int x, int y, int z, Random rand)
     {
         super.updateTick(world, x, y, z, rand);
-        if(world.getBlockMetadata(x, y, z) == 0)
+        if(world.getBlockMetadata(x, y, z) == SIDE_NONE)
         {
             onBlockPlacedByWorld(world, x, y, z);
         }
@@ -114,23 +133,23 @@ public class TorchBlock extends Block
     {
         if(world.isBlockNormalCube(x - 1, y, z))
         {
-            world.setBlockMetadataWithNotify(x, y, z, 1);
+            world.setBlockMetadataWithNotify(x, y, z, SIDE_WEST);
         } else
         if(world.isBlockNormalCube(x + 1, y, z))
         {
-            world.setBlockMetadataWithNotify(x, y, z, 2);
+            world.setBlockMetadataWithNotify(x, y, z, SIDE_EAST);
         } else
         if(world.isBlockNormalCube(x, y, z - 1))
         {
-            world.setBlockMetadataWithNotify(x, y, z, 3);
+            world.setBlockMetadataWithNotify(x, y, z, SIDE_NORTH);
         } else
         if(world.isBlockNormalCube(x, y, z + 1))
         {
-            world.setBlockMetadataWithNotify(x, y, z, 4);
+            world.setBlockMetadataWithNotify(x, y, z, SIDE_SOUTH);
         } else
         if(canPlaceOnTop(world, x, y - 1, z))
         {
-            world.setBlockMetadataWithNotify(x, y, z, 5);
+            world.setBlockMetadataWithNotify(x, y, z, SIDE_BOTTOM);
         }
         dropTorchIfCantStay(world, x, y, z);
     }
@@ -138,44 +157,40 @@ public class TorchBlock extends Block
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
-        if(dropTorchIfCantStay(world, x, y, z))
+        boolean invalid;
+        int side = world.getBlockMetadata(x, y, z) & MASK_DIRECTION;
+        switch (side) {
+            case SIDE_WEST:
+                invalid = !world.isBlockNormalCube(x - 1, y, z);
+                break;
+            case SIDE_EAST:
+                invalid = !world.isBlockNormalCube(x + 1, y, z);
+                break;
+            case SIDE_NORTH:
+                invalid = !world.isBlockNormalCube(x, y, z - 1);
+                break;
+            case SIDE_SOUTH:
+                invalid = !world.isBlockNormalCube(x, y, z + 1);
+                break;
+            case SIDE_BOTTOM:
+                invalid = !world.isBlockNormalCube(x, y - 1, z);
+                break;
+            default:
+                invalid = true;
+        }
+        if(invalid)
         {
-            int i1 = world.getBlockMetadata(x, y, z);
-            boolean flag = false;
-            if(!world.isBlockNormalCube(x - 1, y, z) && i1 == 1)
-            {
-                flag = true;
-            }
-            if(!world.isBlockNormalCube(x + 1, y, z) && i1 == 2)
-            {
-                flag = true;
-            }
-            if(!world.isBlockNormalCube(x, y, z - 1) && i1 == 3)
-            {
-                flag = true;
-            }
-            if(!world.isBlockNormalCube(x, y, z + 1) && i1 == 4)
-            {
-                flag = true;
-            }
-            if(!canPlaceOnTop(world, x, y - 1, z) && i1 == 5)
-            {
-                flag = true;
-            }
-            if(flag)
-            {
-                dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, i1, null, null);
-                world.setBlockWithNotify(x, y, z, 0);
-            }
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, side, null, null);
+            world.setBlockWithNotify(x, y, z, 0);
         }
     }
 
-    private boolean dropTorchIfCantStay(World world, int i, int j, int k)
+    private boolean dropTorchIfCantStay(World world, int x, int y, int z)
     {
-        if(!canPlaceBlockAt(world, i, j, k))
+        if(!canPlaceBlockAt(world, x, y, z))
         {
-            dropBlockWithCause(world, EnumDropCause.WORLD, i, j, k, world.getBlockMetadata(i, j, k), null, null);
-            world.setBlockWithNotify(i, j, k, 0);
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
+            world.setBlockWithNotify(x, y, z, 0);
             return false;
         } else
         {
@@ -186,27 +201,25 @@ public class TorchBlock extends Block
     @Override
     public HitResult collisionRayTrace(World world, int x, int y, int z, Vec3 start, Vec3 end)
     {
-        int l = world.getBlockMetadata(x, y, z) & 7;
         float f = 0.15F;
-        if(l == 1)
-        {
-            setBlockBounds(0.0F, 0.2F, 0.5F - f, f * 2.0F, 0.8F, 0.5F + f);
-        } else
-        if(l == 2)
-        {
-            setBlockBounds(1.0F - f * 2.0F, 0.2F, 0.5F - f, 1.0F, 0.8F, 0.5F + f);
-        } else
-        if(l == 3)
-        {
-            setBlockBounds(0.5F - f, 0.2F, 0.0F, 0.5F + f, 0.8F, f * 2.0F);
-        } else
-        if(l == 4)
-        {
-            setBlockBounds(0.5F - f, 0.2F, 1.0F - f * 2.0F, 0.5F + f, 0.8F, 1.0F);
-        } else
-        {
-            float f1 = 0.1F;
-            setBlockBounds(0.5F - f1, 0.0F, 0.5F - f1, 0.5F + f1, 0.6F, 0.5F + f1);
+        int side = world.getBlockMetadata(x, y, z) & MASK_DIRECTION;
+        switch (side) {
+            case SIDE_WEST:
+                setBlockBounds(0.0F, 0.2F, 0.5F - f, f * 2.0F, 0.8F, 0.5F + f);
+                break;
+            case SIDE_EAST:
+                setBlockBounds(1.0F - f * 2.0F, 0.2F, 0.5F - f, 1.0F, 0.8F, 0.5F + f);
+                break;
+            case SIDE_NORTH:
+                setBlockBounds(0.5F - f, 0.2F, 0.0F, 0.5F + f, 0.8F, f * 2.0F);
+                break;
+            case SIDE_SOUTH:
+                setBlockBounds(0.5F - f, 0.2F, 1.0F - f * 2.0F, 0.5F + f, 0.8F, 1.0F);
+                break;
+            case SIDE_BOTTOM:
+                final float f1 = 0.1F;
+                setBlockBounds(0.5F - f1, 0.0F, 0.5F - f1, 0.5F + f1, 0.6F, 0.5F + f1);
+                break;
         }
         return super.collisionRayTrace(world, x, y, z, start, end);
     }
@@ -214,35 +227,33 @@ public class TorchBlock extends Block
     @Override
 	public void animationTick(World world, int x, int y, int z, Random rand)
     {
-        int l = world.getBlockMetadata(x, y, z);
         double xPos = (double) x + 0.5D;
         double yPos = (double) y + 0.7D;
         double zPos = (double) z + 0.5D;
         double d3 = 0.22D;
         double d4 = 0.27D;
-        if(l == 1)
-        {
-            world.spawnParticle("smoke", xPos - d4, yPos + d3, zPos, 0.0D, 0.0D, 0.0D, 0);
-            world.spawnParticle("flame", xPos - d4, yPos + d3, zPos, 0.0D, 0.0D, 0.0D, 0);
-        } else
-        if(l == 2)
-        {
-            world.spawnParticle("smoke", xPos + d4, yPos + d3, zPos, 0.0D, 0.0D, 0.0D, 0);
-            world.spawnParticle("flame", xPos + d4, yPos + d3, zPos, 0.0D, 0.0D, 0.0D, 0);
-        } else
-        if(l == 3)
-        {
-            world.spawnParticle("smoke", xPos, yPos + d3, zPos - d4, 0.0D, 0.0D, 0.0D, 0);
-            world.spawnParticle("flame", xPos, yPos + d3, zPos - d4, 0.0D, 0.0D, 0.0D, 0);
-        } else
-        if(l == 4)
-        {
-            world.spawnParticle("smoke", xPos, yPos + d3, zPos + d4, 0.0D, 0.0D, 0.0D, 0);
-            world.spawnParticle("flame", xPos, yPos + d3, zPos + d4, 0.0D, 0.0D, 0.0D, 0);
-        } else
-        {
-            world.spawnParticle("smoke", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D, 0);
-            world.spawnParticle("flame", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D, 0);
+        int side = world.getBlockMetadata(x, y, z) & MASK_DIRECTION;
+        switch (side) {
+            case SIDE_WEST:
+                world.spawnParticle("smoke", xPos - d4, yPos + d3, zPos, 0.0D, 0.0D, 0.0D, 0);
+                world.spawnParticle("flame", xPos - d4, yPos + d3, zPos, 0.0D, 0.0D, 0.0D, 0);
+                break;
+            case SIDE_EAST:
+                world.spawnParticle("smoke", xPos + d4, yPos + d3, zPos, 0.0D, 0.0D, 0.0D, 0);
+                world.spawnParticle("flame", xPos + d4, yPos + d3, zPos, 0.0D, 0.0D, 0.0D, 0);
+                break;
+            case SIDE_NORTH:
+                world.spawnParticle("smoke", xPos, yPos + d3, zPos - d4, 0.0D, 0.0D, 0.0D, 0);
+                world.spawnParticle("flame", xPos, yPos + d3, zPos - d4, 0.0D, 0.0D, 0.0D, 0);
+                break;
+            case SIDE_SOUTH:
+                world.spawnParticle("smoke", xPos, yPos + d3, zPos + d4, 0.0D, 0.0D, 0.0D, 0);
+                world.spawnParticle("flame", xPos, yPos + d3, zPos + d4, 0.0D, 0.0D, 0.0D, 0);
+                break;
+            case SIDE_BOTTOM:
+                world.spawnParticle("smoke", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D, 0);
+                world.spawnParticle("flame", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D, 0);
+                break;
         }
     }
     
diff --git a/src/main/java/net/minecraft/core/block/TrapDoorBlock.java b/src/main/java/net/minecraft/core/block/TrapDoorBlock.java
index ea399580d..1207293a9 100644
--- a/src/main/java/net/minecraft/core/block/TrapDoorBlock.java
+++ b/src/main/java/net/minecraft/core/block/TrapDoorBlock.java
@@ -2,7 +2,6 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.PlacementMode;
 import net.minecraft.core.item.Item;
@@ -19,11 +18,12 @@ import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-// Referenced classes of package net.minecraft.src:
-//            Block, Material, IBlockAccess, World, 
-//            AxisAlignedBB, Player, Vec3D, MovingObjectPosition
-
 public class TrapDoorBlock extends Block {
+    public static final int DIRECTION_SOUTH = 0;
+    public static final int DIRECTION_NORTH = 1;
+    public static final int DIRECTION_EAST = 2;
+    public static final int DIRECTION_WEST = 3;
+
     public static final int MASK_DIRECTION = 0b0000_0011;
     public static final int MASK_OPEN = 0b0000_0100;
     public static final int MASK_UPPER_HALF = 0b0000_1000;
@@ -36,9 +36,7 @@ public class TrapDoorBlock extends Block {
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
-        super.onBlockPlacedByMob(world, x, y, z, side, mob, sideHeight);
-
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
         int meta = world.getBlockMetadata(x, y, z);
         boolean isOpened = isTrapdoorOpen(meta);
         boolean isPowered = world.hasNeighborSignal(x, y, z);
@@ -72,30 +70,27 @@ public class TrapDoorBlock extends Block {
 
     @Override
     public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z) {
-        setBlockBoundsForBlockRender(world.getBlockMetadata(x, y, z));
-    }
-
-    public void setBlockBoundsForBlockRender(int i) {
-        float f = 0.1875F;
+        int meta = world.getBlockMetadata(x, y, z);
+        float thickness = 3/16f;
 
-        if (isTrapdoorOpen(i)) {
-            if ((i & 3) == 0) {
-                setBlockBounds(0.0F, 0.0F, 1.0F - f, 1.0F, 1.0F, 1.0F);
+        if (isTrapdoorOpen(meta)) {
+            if ((meta & MASK_DIRECTION) == DIRECTION_SOUTH) { // South
+                setBlockBounds(0.0F, 0.0F, 1.0F - thickness, 1.0F, 1.0F, 1.0F);
             }
-            if ((i & 3) == 1) {
-                setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, f);
+            if ((meta & MASK_DIRECTION) == DIRECTION_NORTH) { // North
+                setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, thickness);
             }
-            if ((i & 3) == 2) {
-                setBlockBounds(1.0F - f, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+            if ((meta & MASK_DIRECTION) == DIRECTION_EAST) { // East
+                setBlockBounds(1.0F - thickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
             }
-            if ((i & 3) == 3) {
-                setBlockBounds(0.0F, 0.0F, 0.0F, f, 1.0F, 1.0F);
+            if ((meta & MASK_DIRECTION) == DIRECTION_WEST) { // West
+                setBlockBounds(0.0F, 0.0F, 0.0F, thickness, 1.0F, 1.0F);
             }
         } else {
-            if (isUpperHalf(i)) {
-                setBlockBounds(0.0F, 1.0f - f, 0.0F, 1.0F, 1.0f, 1.0F);
+            if (isUpperHalf(meta)) {
+                setBlockBounds(0.0F, 1.0f - thickness, 0.0F, 1.0F, 1.0f, 1.0F);
             } else {
-                setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, f, 1.0F);
+                setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, thickness, 1.0F);
             }
         }
     }
@@ -111,7 +106,7 @@ public class TrapDoorBlock extends Block {
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced) {
         if (blockMaterial != Material.metal) {
             int l = world.getBlockMetadata(x, y, z);
-            world.setBlockMetadataWithNotify(x, y, z, l ^ 4);
+            world.setBlockMetadataWithNotify(x, y, z, l ^ MASK_OPEN);
             world.playBlockEvent(player, LevelListener.EVENT_DOOR_SOUND, x, y, z, 0);
             return true;
         }
@@ -122,7 +117,7 @@ public class TrapDoorBlock extends Block {
     public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
         if (blockMaterial != Material.metal) {
             int l = world.getBlockMetadata(x, y, z);
-            world.setBlockMetadataWithNotify(x, y, z, l ^ 4);
+            world.setBlockMetadataWithNotify(x, y, z, l ^ MASK_OPEN);
             world.playBlockEvent(null, LevelListener.EVENT_DOOR_SOUND, x, y, z, 0);
         }
     }
@@ -153,7 +148,7 @@ public class TrapDoorBlock extends Block {
     public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
         int meta = getMetaForDirection(player == null ? side.getDirection().getOpposite() : player.getHorizontalPlacementDirection(side, PlacementMode.SIDE));
         if (player != null && player.getVerticalPlacementDirection(side, yPlaced) == Direction.UP) {
-            meta |= 8;
+            meta = setUpperHalf(meta, true);
         }
         return meta;
     }
@@ -198,11 +193,20 @@ public class TrapDoorBlock extends Block {
     }
 
     public int getMetaForDirection(Direction dir) {
-        return dir.getId();
+        switch (dir) {
+            case SOUTH:
+                return DIRECTION_SOUTH;
+            case NORTH:
+                return DIRECTION_NORTH;
+            case EAST:
+                return DIRECTION_EAST;
+            case WEST:
+                return DIRECTION_WEST;
+        }
+        return 0;
     }
 
     public Direction getDirectionForMeta(int meta) {
-        meta = meta & MASK_DIRECTION;
-        return Direction.getDirectionById(meta);
+        return Direction.getDirectionById(meta & MASK_DIRECTION);
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/TrommelBlock.java b/src/main/java/net/minecraft/core/block/TrommelBlock.java
index 2a33d21da..af600fa24 100644
--- a/src/main/java/net/minecraft/core/block/TrommelBlock.java
+++ b/src/main/java/net/minecraft/core/block/TrommelBlock.java
@@ -24,13 +24,6 @@ public class TrommelBlock extends RotatableEntityBlock
         this.isActive = isActive;
     }
 
-    @Override
-	public void onBlockPlacedByWorld(World world, int x, int y, int z)
-    {
-        super.onBlockPlacedByWorld(world, x, y, z);
-        setDefaultDirection(world, x, y, z);
-    }
-
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
     {
diff --git a/src/main/java/net/minecraft/core/block/VeryRotatableEntityBlock.java b/src/main/java/net/minecraft/core/block/VeryRotatableEntityBlock.java
index 8b2403694..8039803b6 100644
--- a/src/main/java/net/minecraft/core/block/VeryRotatableEntityBlock.java
+++ b/src/main/java/net/minecraft/core/block/VeryRotatableEntityBlock.java
@@ -2,28 +2,44 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Mob;
-import net.minecraft.core.enums.PlacementMode;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
+import org.jetbrains.annotations.NotNull;
 
 public abstract class VeryRotatableEntityBlock extends RotatableEntityBlock {
+    public static final int MASK_DIRECTION = 0b0000_0111;
 	public VeryRotatableEntityBlock(String key, String namespaceId, int id, Material material) {
         super(key, namespaceId, id, material);
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
         final Direction direction = mob.getPlacementDirection(side).getOpposite();
 
         world.setBlockMetadataWithNotify(x, y, z, directionToMeta(direction));
     }
 
+    @Override
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+        final Direction direction = side.getOpposite().getDirection();
+
+        world.setBlockMetadataWithNotify(x, y, z, directionToMeta(direction));
+    }
+
     public static int directionToMeta(Direction direction) {
-        return direction.getId() & 7;
+        return direction.getId() & MASK_DIRECTION;
     }
 
     public static Direction metaToDirection(int meta) {
-        return Direction.getDirectionById(meta & 7);
+        return Direction.getDirectionById(meta & MASK_DIRECTION);
+    }
+
+    @Override
+    public void onBlockPlacedByActivator(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction)
+    {
+        super.onBlockPlacedByActivator(world, x, y, z, activator, direction);
+        world.setBlockMetadataWithNotify(x, y, z, RotatableBlock.setDirection(0, direction));
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/BlockEntity.java b/src/main/java/net/minecraft/core/block/entity/BlockEntity.java
index 8328f58f0..c98efbf41 100644
--- a/src/main/java/net/minecraft/core/block/entity/BlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/BlockEntity.java
@@ -142,7 +142,7 @@ public class BlockEntity implements ICarriable
         world.setBlockTileEntity(x, y, z, this);
         Block b = world.getBlock(x, y, z);
         if (b != null && holder instanceof Mob) {
-            b.onBlockPlacedByMob(world, x, y, z, side, (Mob) holder, yPlaced);
+            b.onBlockPlacedByMob(world, x, y, z, side, (Mob) holder, xPlaced, yPlaced);
         }
         world.notifyBlockChange(x, y, z, carriedBlock.blockId);
         return true;
@@ -178,9 +178,7 @@ public class BlockEntity implements ICarriable
         Block currentBlock = world.getBlock(x, y, z);
         int currentMeta = world.getBlockMetadata(x, y, z);
         world.removeBlockTileEntity(x, y, z);
-        Chunk c = world.getChunkFromBlockCoords(x, z);
-        c.setBlockIDRaw(x & 0b1111, y, z & 0b1111, 0);
-        c.recalcHeightmap();
+        world.setBlockRaw(x & 0b1111, y, z & 0b1111, 0);
         world.notifyBlockChange(x, y, z, 0);
         this.worldObj = null;
         this.carriedBlock = getCarriedEntry(world, holder, currentBlock, currentMeta);
diff --git a/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java b/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java
index dd643a210..4825e7d17 100644
--- a/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java
+++ b/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java
@@ -15,8 +15,6 @@ import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-import java.util.Objects;
-
 public class CarriedBlock implements ICarriable {
     public int blockId;
     public int metadata;
@@ -66,7 +64,7 @@ public class CarriedBlock implements ICarriable {
 
             Block b = world.getBlock(x, y, z);
             if (b != null && holder instanceof Mob) {
-                b.onBlockPlacedByMob(world, x, y, z, side, (Mob) holder, yPlaced);
+                b.onBlockPlacedByMob(world, x, y, z, side, (Mob) holder, xPlaced, yPlaced);
             }
             return true;
         }
diff --git a/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java b/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
index 375b508c8..30de4c93f 100644
--- a/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
@@ -3,6 +3,7 @@ package net.minecraft.core.block.piston;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.entity.BlockEntityDispatcher;
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.AABB;
@@ -143,9 +144,7 @@ public class MovingPistonBlockEntity extends BlockEntity
         worldObj.removeBlockTileEntity(x, y, z);
         invalidate();
         if(worldObj.getBlockId(x, y, z) == Blocks.PISTON_MOVING.id) {
-            // Don't combine these into setBlockAndMetadata, then onBlockPlacedByWorld can override the metadata
-            worldObj.setBlock(x, y, z, movedId);
-            worldObj.setBlockMetadata(x, y, z, movedData);
+            worldObj.setBlockAndMetadataRaw(x, y, z, movedId, movedData);
             if (movedEntity != null) {
                 BlockEntity oldEnt = worldObj.getBlockEntity(x, y, z);
                 if (oldEnt != null) {
@@ -157,6 +156,9 @@ public class MovingPistonBlockEntity extends BlockEntity
                 movedEntity.z = z;
                 worldObj.replaceBlockTileEntity(x, y, z, movedEntity);
             }
+            if (movedId != 0) {
+                Block.blocksList[movedId].onBlockPlacedByWorld(worldObj, x, y, z);
+            }
             worldObj.notifyBlockChange(x, y, z, movedId);
         }
     }
diff --git a/src/main/java/net/minecraft/core/block/piston/PistonBaseBlock.java b/src/main/java/net/minecraft/core/block/piston/PistonBaseBlock.java
index f1adc8914..de25b0b39 100644
--- a/src/main/java/net/minecraft/core/block/piston/PistonBaseBlock.java
+++ b/src/main/java/net/minecraft/core/block/piston/PistonBaseBlock.java
@@ -45,7 +45,7 @@ public class PistonBaseBlock extends Block
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
     	Direction placementDirection = mob.getPlacementDirection(side).getOpposite();
         world.setBlockMetadataWithNotify(x, y, z, placementDirection.getId());
         if(!world.isClientSide)
@@ -54,6 +54,16 @@ public class PistonBaseBlock extends Block
         }
     }
 
+    @Override
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+        Direction placementDirection = side.getOpposite().getDirection();
+        world.setBlockMetadataWithNotify(x, y, z, placementDirection.getId());
+        if(!world.isClientSide)
+        {
+            checkIfExtend(world, x, y, z);
+        }
+    }
+
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
@@ -135,7 +145,7 @@ public class PistonBaseBlock extends Block
     public void triggerEvent(World world, int x, int y, int z, int index, int data)
     {
         Direction direction = getDirection(data);
-        if (direction == Direction.NONE) direction = Direction.DOWN; // Probably going to end with a downwards facing bedrock breaker
+        if (direction == Direction.NONE) return;
         if(index == EVENT_EXTEND)
         {
             extendEvent(world, x, y, z, data, direction);
@@ -339,7 +349,7 @@ public class PistonBaseBlock extends Block
             int pushId = world.getBlockId(px, py, pz);
             int pushMeta = world.getBlockMetadata(px, py, pz);
             BlockEntity pushEntity = world.getBlockEntity(px, py, pz);
-            if (pushEntity instanceof MovingPistonBlockEntity) {
+            if (pushEntity instanceof MovingPistonBlockEntity && px == x && py == y && pz == z) {
                 break;
             }
             if(pushId == id && px == x && py == y && pz == z)
@@ -365,6 +375,8 @@ public class PistonBaseBlock extends Block
                 world.setBlockAndMetadata(xo, yo, zo, Blocks.PISTON_MOVING.id, pushMeta);
                 world.replaceBlockTileEntity(xo, yo, zo, MovingPistonBlock.createTileEntity(pushId, pushMeta, pushEntity, direction, true, false));
             }
+            if (!(px == x && py == y && pz == z))
+                world.setBlockAndMetadataRaw(px, py, pz, 0, 0);
             xo = px;
             yo = py;
             zo = pz;
diff --git a/src/main/java/net/minecraft/core/data/gamerule/GameRules.java b/src/main/java/net/minecraft/core/data/gamerule/GameRules.java
index 2c19c2f27..ef514cbfc 100644
--- a/src/main/java/net/minecraft/core/data/gamerule/GameRules.java
+++ b/src/main/java/net/minecraft/core/data/gamerule/GameRules.java
@@ -13,6 +13,7 @@ public abstract class GameRules
     public static GameRuleBoolean DWARF_MODE = register(new GameRuleBoolean("dwarfMode", false));
     public static GameRuleBoolean MOB_GRIEFING = register(new GameRuleBoolean("mobGriefing", true));
     public static GameRuleBoolean DO_DAY_CYCLE = register(new GameRuleBoolean("doDaylightCycle", true));
+    public static GameRuleBoolean DO_WEATHER_CYCLE = register(new GameRuleBoolean("doWeatherCycle", true));
     public static GameRuleBoolean INSTANT_HEALING = register(new GameRuleBoolean("instantHealing", false));
 
     public static <T extends GameRule<?>> T register(T gameRule)
diff --git a/src/main/java/net/minecraft/core/data/gamerule/TreecapitatorHelper.java b/src/main/java/net/minecraft/core/data/gamerule/TreecapitatorHelper.java
index 45c6d8828..1c9d670d9 100644
--- a/src/main/java/net/minecraft/core/data/gamerule/TreecapitatorHelper.java
+++ b/src/main/java/net/minecraft/core/data/gamerule/TreecapitatorHelper.java
@@ -12,6 +12,7 @@ import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.ChunkPosition;
 
@@ -206,7 +207,7 @@ public class TreecapitatorHelper {
 				}	
 			}
 			if(particle) {
-				world.playBlockEvent(player, 2001, pos.x, pos.y, pos.z, block.id);
+				world.playBlockEvent(player, LevelListener.EVENT_BLOCK_BREAK, pos.x, pos.y, pos.z, block.id);
 			}
 			return true;
 		}
